#ifndef WATCHY_RTC_H
#define WATCHY_RTC_H

#include "config.h"
#include <Arduino.h>
#include <TimeLib.h>
#include <Rtc_Pcf8563.h>

#define RTC_PCF_ADDR    0x51
#define YEAR_OFFSET_PCF 2000

class WatchyRTC {
public:
  Rtc_Pcf8563 rtc_pcf;

public:
  WatchyRTC();
  void Init();
  void Get(tmElements_t & tm, int offsetInSeconds = 0);
  void Set(tmElements_t tm);
  void SetTimer();
  bool CheckWakeup(); // Checks to really wake up or not, also resets the timer after the initial sleep
  void Resync(); // Resync the timer cycle, both initially and after RTC resync

  static void OffsetTime(tmElements_t & tm, int offsetInSeconds);

private:
  static RTC_DATA_ATTR bool m_timerSet, m_initialTimer;
};

#endif